﻿-- Author      : Apoco
-- Create Date : 4/8/2008 4:40:17 PM
if not RBM then
	DEFAULT_CHAT_FRAME:AddMessage("Trap Watch Could Not Be Loaded.  You need to have RBM Enabled.")
	return
end
if UnitClass("player") ~= "Hunter" then
	DEFAULT_CHAT_FRAME:AddMessage("Trap Watch was not loaded.  Hunters only")
	return
end


local module = RBM:NewPlugin("Trap Watch")
local player = UnitName("player")
local trapped = false

local L = module:GetTranslations()
module:RegisterTranslations("enUS", -- translation automatically generated
	"Freezing Trap", true,
	"Freezing Trap Effect", true,
	"Freezing Trap: Announce", true,
	"Freezing Trap: Announce Cooldown", true,
	"Freezing Trap: Active", true,
	"Trapped", true,
	"Active", true,
	"%s is trapped!", true,
	"%s trap broke!", true
)


function module:OnInitialize()
	self:RegisterToggles(L["Freezing Trap: Announce"], false,
						 L["Freezing Trap: Announce Cooldown"], false
						 )

	self:RegisterCategory(L["Freezing Trap: Active"], L["Freezing Trap: Active"], 0.7, 0.4, 0.7)
	self:RegisterCategory(L["Trapped"], L["Trapped"], 0.3, 0.3, 1.0)
end

function module:OnEnable()
	db = self.db.profile
	self:AddEventListener("COMBAT_LOG_EVENT_UNFILTERED")
	self:AddEventListener("PLAYER_TARGET_CHANGED", "UpdateDebuffs", nil, self, "target")
	self:AddEventListener("PLAYER_FOCUS_CHANGED", "UpdateDebuffs", nil, self, "focus")
	self.ActiveTrap = self:CreateLabel(L["Freezing Trap"], L["Active"])
end

function module:UpdateDebuffs(self, unit)
	local name = UnitName(unit)
	if not name then 
		return 
	end
	
	local label = self:CreateLabel(L["Trapped"], name)
	if self:IsBarActive(label) then
		local i = 1
		while UnitDebuff(unit, i) do
			local aura, _, texture, _, _, duration, remaining = UnitDebuff(unit, i)
			if duration and aura == L["Freezing Trap Effect"] then
				if self:GetBarTimeLeft(label) + .1 < remaining then
					self:SetBarCurrentTime(label, remaining, false)
					if self:IsBarActive(self.ActiveTrap) then
						self:CancelBar(self.ActiveTrap)
					end
				end
			end
			i = i + 1
		end
	end
end

function module:COMBAT_LOG_EVENT_UNFILTERED(_, _, _, event, _, sourceName, _, _, name, _, id)
	if event == "SPELL_CREATE" and sourceName == player and id == 14311 then
		self:LocalTimedBar(self.ActiveTrap, L["Freezing Trap: Active"], 60, "Spell_Frost_ChainsOfIce")
		if self:CheckToggle(L["Freezing Trap: Announce Cooldown"]) then
			self:AddTimer(50, function()
				SendChatMessage(L["Trap Usable in ~10 Seconds"], "PARTY")
			end)
		end
		trapped = true
		self:AddTimer(60, function()
			trapped = false
		end)
		
	elseif event == "SPELL_AURA_APPLIED" and name and id == 14309 and trapped then
		if self:IsBarActive(self.ActiveTrap) then
			self:CancelBar(self.ActiveTrap)
		end
		self:LocalTimedBar(self:CreateLabel(L["Trapped"], name), L["Trapped"], 20, "Spell_Frost_ChainsOfIce", true)
		if self:CheckToggle(L["Freezing Trap: Announce"]) then
			SendChatMessage(string.format(L["%s is trapped!"], name), "PARTY")
		end
	
	elseif event == "SPELL_AURA_REMOVED" and name and id == 14309 and trapped then
		local label = self:CreateLabel(L["Trapped"], name)
		if label then
			if self:IsBarActive(label) then
				self:CancelBar(label)
				self:Alert("Normal", "*** Freezing Trap BROKE! ***")
				if self:CheckToggle(L["Freezing Trap: Announce"]) then
					SendChatMessage(string.format(L["%s trap broke!"], name), "PARTY")
				end
			end
		end
		trapped = false
	end
end